/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.pb162.computer.components;

/**
 *
 * @author apple
 */
public interface Component {
    
    /**
     * Device's id.
     * @return the device id
     */
    String getId();

    /**
     * Whether there are some attached devices
     *
     * @return true if there are attached devices, false otherwise.
     */ 
    boolean hasChildern();

    /**
     * Array of attached devices.
     *
     * @return array of attached devices
     */
    Component[] getChildern();

    /**
     * Can other devices be pluged into the device.
     *
     * @return true if there exists either some slots or usb ports.
     */
    boolean isHub();

    /**
     * Number of free slots.
     *
     * @return The number of free slots for additional cards.
     */
    int getFreeSlots();

    /**
     * The number of free USB ports.
     *
     * @return The number of free usb ports.
     */
    int getFreePorts();
    
    /**
     * Adds component to the device.
     *
     * @param device the device to be added
     * @param where wheter the device should ve added into the slot ("slot") or 
     *              into the USB port ("usb").
     *
     * @return true if the device can be added
     */
    boolean addComponent(Component device, String where);

    /**
     * The string representation of the device.
     *
     * @return the string in form:
     *         <id>: devices: [list of attached devicese] \n
     */
    String toString();
}
